
/*
* Copyright (C) 2004-2014 Texas Instruments Incorporated - http://www.ti.com/
* All rights reserved.	
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*    Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

#ifndef _CSLR__RTC_001_H_
#define _CSLR__RTC_001_H_

#include <cslr.h>

#include <tistdtypes.h>


/* Minimum unit = 1 byte */

/**************************************************************************\
* Register Overlay Structure
\**************************************************************************/
typedef struct  {
    volatile Uint32 SECONDS;
    volatile Uint32 MINUTES;
    volatile Uint32 HOURS;
    volatile Uint32 DAYS;
    volatile Uint32 MONTHS;
    volatile Uint32 YEARS;
    volatile Uint32 WEEKS;
    volatile Uint8 RSVD0[4];
    volatile Uint32 ALARMSECONDS;
    volatile Uint32 ALARMMINUTES;
    volatile Uint32 ALARMHOURS;
    volatile Uint32 ALARMDAYS;
    volatile Uint32 ALARMMONTHS;
    volatile Uint32 ALARMYEARS;
    volatile Uint8 RSVD1[8];
    volatile Uint32 CTRL;
    volatile Uint32 STATUS;
    volatile Uint32 INTERRUPTS;
    volatile Uint32 COMPLSB;
    volatile Uint32 COMPMSB;
    volatile Uint32 OSC;
    volatile Uint8 RSVD2[8];
    volatile Uint32 SCRATCH0;
    volatile Uint32 SCRATCH1;
    volatile Uint32 SCRATCH2;
    volatile Uint32 KICK0;
    volatile Uint32 KICK1;
} CSL_RtcRegs;

/**************************************************************************\
* Field Definition Macros
\**************************************************************************/

/* SECONDS */


#define CSL_RTC_SECONDS_SEC1_MASK (0x000000F0u)
#define CSL_RTC_SECONDS_SEC1_SHIFT (0x00000004u)
#define CSL_RTC_SECONDS_SEC1_RESETVAL (0x00000000u)

#define CSL_RTC_SECONDS_SEC0_MASK (0x0000000Fu)
#define CSL_RTC_SECONDS_SEC0_SHIFT (0x00000000u)
#define CSL_RTC_SECONDS_SEC0_RESETVAL (0x00000000u)

#define CSL_RTC_SECONDS_RESETVAL (0x00000000u)

/* MINUTES */


#define CSL_RTC_MINUTES_MIN1_MASK (0x000000F0u)
#define CSL_RTC_MINUTES_MIN1_SHIFT (0x00000004u)
#define CSL_RTC_MINUTES_MIN1_RESETVAL (0x00000000u)

#define CSL_RTC_MINUTES_MIN0_MASK (0x0000000Fu)
#define CSL_RTC_MINUTES_MIN0_SHIFT (0x00000000u)
#define CSL_RTC_MINUTES_MIN0_RESETVAL (0x00000000u)

#define CSL_RTC_MINUTES_RESETVAL (0x00000000u)

/* HOURS */


#define CSL_RTC_HOURS_MERIDIEM_MASK (0x00000080u)
#define CSL_RTC_HOURS_MERIDIEM_SHIFT (0x00000007u)
#define CSL_RTC_HOURS_MERIDIEM_RESETVAL (0x00000000u)
/*----MERIDIEM Tokens----*/
#define CSL_RTC_HOURS_MERIDIEM_AM (0x00000000u)
#define CSL_RTC_HOURS_MERIDIEM_PM (0x00000001u)

#define CSL_RTC_HOURS_HOUR1_MASK (0x00000070u)
#define CSL_RTC_HOURS_HOUR1_SHIFT (0x00000004u)
#define CSL_RTC_HOURS_HOUR1_RESETVAL (0x00000000u)

#define CSL_RTC_HOURS_HOUR0_MASK (0x0000000Fu)
#define CSL_RTC_HOURS_HOUR0_SHIFT (0x00000000u)
#define CSL_RTC_HOURS_HOUR0_RESETVAL (0x00000000u)

#define CSL_RTC_HOURS_RESETVAL (0x00000000u)

/* DAYS */


#define CSL_RTC_DAYS_DAY1_MASK (0x000000F0u)
#define CSL_RTC_DAYS_DAY1_SHIFT (0x00000004u)
#define CSL_RTC_DAYS_DAY1_RESETVAL (0x00000000u)

#define CSL_RTC_DAYS_DAY0_MASK (0x0000000Fu)
#define CSL_RTC_DAYS_DAY0_SHIFT (0x00000000u)
#define CSL_RTC_DAYS_DAY0_RESETVAL (0x00000001u)

#define CSL_RTC_DAYS_RESETVAL (0x00000001u)

/* MONTHS */


#define CSL_RTC_MONTHS_MONTH1_MASK (0x000000F0u)
#define CSL_RTC_MONTHS_MONTH1_SHIFT (0x00000004u)
#define CSL_RTC_MONTHS_MONTH1_RESETVAL (0x00000000u)

#define CSL_RTC_MONTHS_MONTH0_MASK (0x0000000Fu)
#define CSL_RTC_MONTHS_MONTH0_SHIFT (0x00000000u)
#define CSL_RTC_MONTHS_MONTH0_RESETVAL (0x00000001u)

#define CSL_RTC_MONTHS_RESETVAL (0x00000001u)

/* YEARS */


#define CSL_RTC_YEARS_YEAR1_MASK (0x000000F0u)
#define CSL_RTC_YEARS_YEAR1_SHIFT (0x00000004u)
#define CSL_RTC_YEARS_YEAR1_RESETVAL (0x00000000u)

#define CSL_RTC_YEARS_YEAR0_MASK (0x0000000Fu)
#define CSL_RTC_YEARS_YEAR0_SHIFT (0x00000000u)
#define CSL_RTC_YEARS_YEAR0_RESETVAL (0x00000000u)

#define CSL_RTC_YEARS_RESETVAL (0x00000000u)

/* WEEKS */


#define CSL_RTC_WEEKS_WEEK_MASK (0x0000000Fu)
#define CSL_RTC_WEEKS_WEEK_SHIFT (0x00000000u)
#define CSL_RTC_WEEKS_WEEK_RESETVAL (0x00000000u)

#define CSL_RTC_WEEKS_RESETVAL (0x00000000u)

/* ALARMSECONDS */


#define CSL_RTC_ALARMSECONDS_SEC1_MASK (0x000000F0u)
#define CSL_RTC_ALARMSECONDS_SEC1_SHIFT (0x00000004u)
#define CSL_RTC_ALARMSECONDS_SEC1_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMSECONDS_SEC0_MASK (0x0000000Fu)
#define CSL_RTC_ALARMSECONDS_SEC0_SHIFT (0x00000000u)
#define CSL_RTC_ALARMSECONDS_SEC0_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMSECONDS_RESETVAL (0x00000000u)

/* ALARMMINUTES */


#define CSL_RTC_ALARMMINUTES_MIN1_MASK (0x000000F0u)
#define CSL_RTC_ALARMMINUTES_MIN1_SHIFT (0x00000004u)
#define CSL_RTC_ALARMMINUTES_MIN1_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMMINUTES_MIN0_MASK (0x0000000Fu)
#define CSL_RTC_ALARMMINUTES_MIN0_SHIFT (0x00000000u)
#define CSL_RTC_ALARMMINUTES_MIN0_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMMINUTES_RESETVAL (0x00000000u)

/* ALARMHOURS */


#define CSL_RTC_ALARMHOURS_MERIDIEM_MASK (0x00000080u)
#define CSL_RTC_ALARMHOURS_MERIDIEM_SHIFT (0x00000007u)
#define CSL_RTC_ALARMHOURS_MERIDIEM_RESETVAL (0x00000000u)
/*----MERIDIEM Tokens----*/
#define CSL_RTC_ALARMHOURS_MERIDIEM_AM (0x00000000u)
#define CSL_RTC_ALARMHOURS_MERIDIEM_PM (0x00000001u)

#define CSL_RTC_ALARMHOURS_HOUR1_MASK (0x00000070u)
#define CSL_RTC_ALARMHOURS_HOUR1_SHIFT (0x00000004u)
#define CSL_RTC_ALARMHOURS_HOUR1_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMHOURS_HOUR0_MASK (0x0000000Fu)
#define CSL_RTC_ALARMHOURS_HOUR0_SHIFT (0x00000000u)
#define CSL_RTC_ALARMHOURS_HOUR0_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMHOURS_RESETVAL (0x00000000u)

/* ALARMDAYS */


#define CSL_RTC_ALARMDAYS_DAY1_MASK (0x000000F0u)
#define CSL_RTC_ALARMDAYS_DAY1_SHIFT (0x00000004u)
#define CSL_RTC_ALARMDAYS_DAY1_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMDAYS_DAY0_MASK (0x0000000Fu)
#define CSL_RTC_ALARMDAYS_DAY0_SHIFT (0x00000000u)
#define CSL_RTC_ALARMDAYS_DAY0_RESETVAL (0x00000001u)

#define CSL_RTC_ALARMDAYS_RESETVAL (0x00000001u)

/* ALARMMONTHS */


#define CSL_RTC_ALARMMONTHS_MONTH1_MASK (0x000000F0u)
#define CSL_RTC_ALARMMONTHS_MONTH1_SHIFT (0x00000004u)
#define CSL_RTC_ALARMMONTHS_MONTH1_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMMONTHS_MONTH0_MASK (0x0000000Fu)
#define CSL_RTC_ALARMMONTHS_MONTH0_SHIFT (0x00000000u)
#define CSL_RTC_ALARMMONTHS_MONTH0_RESETVAL (0x00000001u)

#define CSL_RTC_ALARMMONTHS_RESETVAL (0x00000001u)

/* ALARMYEARS */


#define CSL_RTC_ALARMYEARS_YEAR1_MASK (0x000000F0u)
#define CSL_RTC_ALARMYEARS_YEAR1_SHIFT (0x00000004u)
#define CSL_RTC_ALARMYEARS_YEAR1_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMYEARS_YEAR0_MASK (0x0000000Fu)
#define CSL_RTC_ALARMYEARS_YEAR0_SHIFT (0x00000000u)
#define CSL_RTC_ALARMYEARS_YEAR0_RESETVAL (0x00000000u)

#define CSL_RTC_ALARMYEARS_RESETVAL (0x00000000u)

/* CTRL */


#define CSL_RTC_CTRL_SPLITPOWER_MASK (0x00000080u)
#define CSL_RTC_CTRL_SPLITPOWER_SHIFT (0x00000007u)
#define CSL_RTC_CTRL_SPLITPOWER_RESETVAL (0x00000000u)
/*----SPLITPOWER Tokens----*/
#define CSL_RTC_CTRL_SPLITPOWER_DISABLE (0x00000000u)
#define CSL_RTC_CTRL_SPLITPOWER_ENABLE (0x00000001u)

#define CSL_RTC_CTRL_RTCDISABLE_MASK (0x00000040u)
#define CSL_RTC_CTRL_RTCDISABLE_SHIFT (0x00000006u)
#define CSL_RTC_CTRL_RTCDISABLE_RESETVAL (0x00000000u)
/*----RTCDISABLE Tokens----*/
#define CSL_RTC_CTRL_RTCDISABLE_ENABLE (0x00000000u)
#define CSL_RTC_CTRL_RTCDISABLE_DISABLE (0x00000001u)

#define CSL_RTC_CTRL_SET32COUNTER_MASK (0x00000020u)
#define CSL_RTC_CTRL_SET32COUNTER_SHIFT (0x00000005u)
#define CSL_RTC_CTRL_SET32COUNTER_RESETVAL (0x00000000u)
/*----SET32COUNTER Tokens----*/
#define CSL_RTC_CTRL_SET32COUNTER_DISABLE (0x00000000u)
#define CSL_RTC_CTRL_SET32COUNTER_ENABLE (0x00000001u)

#define CSL_RTC_CTRL_TESTMODE_MASK (0x00000010u)
#define CSL_RTC_CTRL_TESTMODE_SHIFT (0x00000004u)
#define CSL_RTC_CTRL_TESTMODE_RESETVAL (0x00000000u)
/*----TESTMODE Tokens----*/
#define CSL_RTC_CTRL_TESTMODE_DISABLE (0x00000000u)
#define CSL_RTC_CTRL_TESTMODE_ENABLE (0x00000001u)

#define CSL_RTC_CTRL_HOURMODE_MASK (0x00000008u)
#define CSL_RTC_CTRL_HOURMODE_SHIFT (0x00000003u)
#define CSL_RTC_CTRL_HOURMODE_RESETVAL (0x00000000u)
/*----HOURMODE Tokens----*/
#define CSL_RTC_CTRL_HOURMODE_24HR (0x00000000u)
#define CSL_RTC_CTRL_HOURMODE_12HR (0x00000001u)

#define CSL_RTC_CTRL_AUTOCOMP_MASK (0x00000004u)
#define CSL_RTC_CTRL_AUTOCOMP_SHIFT (0x00000002u)
#define CSL_RTC_CTRL_AUTOCOMP_RESETVAL (0x00000000u)
/*----AUTOCOMP Tokens----*/
#define CSL_RTC_CTRL_AUTOCOMP_DISABLE (0x00000000u)
#define CSL_RTC_CTRL_AUTOCOMP_ENABLE (0x00000001u)

#define CSL_RTC_CTRL_ROUNDMIN_MASK (0x00000002u)
#define CSL_RTC_CTRL_ROUNDMIN_SHIFT (0x00000001u)
#define CSL_RTC_CTRL_ROUNDMIN_RESETVAL (0x00000000u)
/*----ROUNDMIN Tokens----*/
#define CSL_RTC_CTRL_ROUNDMIN_DISABLE (0x00000000u)
#define CSL_RTC_CTRL_ROUNDMIN_ENABLE (0x00000001u)

#define CSL_RTC_CTRL_STOPRTC_MASK (0x00000001u)
#define CSL_RTC_CTRL_STOPRTC_SHIFT (0x00000000u)
#define CSL_RTC_CTRL_STOPRTC_RESETVAL (0x00000000u)
/*----STOPRTC Tokens----*/
#define CSL_RTC_CTRL_STOPRTC_STOP (0x00000000u)
#define CSL_RTC_CTRL_STOPRTC_RUN (0x00000001u)

#define CSL_RTC_CTRL_RESETVAL (0x00000000u)

/* STATUS */


#define CSL_RTC_STATUS_POWERUP_MASK (0x00000080u)
#define CSL_RTC_STATUS_POWERUP_SHIFT (0x00000007u)
#define CSL_RTC_STATUS_POWERUP_RESETVAL (0x00000001u)

#define CSL_RTC_STATUS_ALARM_MASK (0x00000040u)
#define CSL_RTC_STATUS_ALARM_SHIFT (0x00000006u)
#define CSL_RTC_STATUS_ALARM_RESETVAL (0x00000000u)

#define CSL_RTC_STATUS_DAYEVT_MASK (0x00000020u)
#define CSL_RTC_STATUS_DAYEVT_SHIFT (0x00000005u)
#define CSL_RTC_STATUS_DAYEVT_RESETVAL (0x00000000u)

#define CSL_RTC_STATUS_HREVT_MASK (0x00000010u)
#define CSL_RTC_STATUS_HREVT_SHIFT (0x00000004u)
#define CSL_RTC_STATUS_HREVT_RESETVAL (0x00000000u)

#define CSL_RTC_STATUS_MINEVT_MASK (0x00000008u)
#define CSL_RTC_STATUS_MINEVT_SHIFT (0x00000003u)
#define CSL_RTC_STATUS_MINEVT_RESETVAL (0x00000000u)

#define CSL_RTC_STATUS_SECEVT_MASK (0x00000004u)
#define CSL_RTC_STATUS_SECEVT_SHIFT (0x00000002u)
#define CSL_RTC_STATUS_SECEVT_RESETVAL (0x00000000u)

#define CSL_RTC_STATUS_RUN_MASK (0x00000002u)
#define CSL_RTC_STATUS_RUN_SHIFT (0x00000001u)
#define CSL_RTC_STATUS_RUN_RESETVAL (0x00000000u)
/*----RUN Tokens----*/
#define CSL_RTC_STATUS_RUN_STOP (0x00000000u)
#define CSL_RTC_STATUS_RUN_RUN (0x00000001u)

#define CSL_RTC_STATUS_BUSY_MASK (0x00000001u)
#define CSL_RTC_STATUS_BUSY_SHIFT (0x00000000u)
#define CSL_RTC_STATUS_BUSY_RESETVAL (0x00000000u)
/*----BUSY Tokens----*/
#define CSL_RTC_STATUS_BUSY_FREE (0x00000000u)
#define CSL_RTC_STATUS_BUSY_BUSY (0x00000001u)

#define CSL_RTC_STATUS_RESETVAL (0x00000080u)

/* INTERRUPTS */


#define CSL_RTC_INTERRUPTS_ALARM_MASK (0x00000008u)
#define CSL_RTC_INTERRUPTS_ALARM_SHIFT (0x00000003u)
#define CSL_RTC_INTERRUPTS_ALARM_RESETVAL (0x00000000u)
/*----ALARM Tokens----*/
#define CSL_RTC_INTERRUPTS_ALARM_DISABLE (0x00000000u)
#define CSL_RTC_INTERRUPTS_ALARM_ENABLE (0x00000001u)

#define CSL_RTC_INTERRUPTS_TIMER_MASK (0x00000004u)
#define CSL_RTC_INTERRUPTS_TIMER_SHIFT (0x00000002u)
#define CSL_RTC_INTERRUPTS_TIMER_RESETVAL (0x00000000u)
/*----TIMER Tokens----*/
#define CSL_RTC_INTERRUPTS_TIMER_DISABLE (0x00000000u)
#define CSL_RTC_INTERRUPTS_TIMER_ENABLE (0x00000001u)

#define CSL_RTC_INTERRUPTS_EVERY_MASK (0x00000003u)
#define CSL_RTC_INTERRUPTS_EVERY_SHIFT (0x00000000u)
#define CSL_RTC_INTERRUPTS_EVERY_RESETVAL (0x00000000u)
/*----EVERY Tokens----*/
#define CSL_RTC_INTERRUPTS_EVERY_SECOND (0x00000000u)
#define CSL_RTC_INTERRUPTS_EVERY_MINUTE (0x00000001u)
#define CSL_RTC_INTERRUPTS_EVERY_HOUR (0x00000002u)
#define CSL_RTC_INTERRUPTS_EVERY_DAY (0x00000003u)

#define CSL_RTC_INTERRUPTS_RESETVAL (0x00000000u)

/* COMPLSB */


#define CSL_RTC_COMPLSB_COMPLSB_MASK (0x000000FFu)
#define CSL_RTC_COMPLSB_COMPLSB_SHIFT (0x00000000u)
#define CSL_RTC_COMPLSB_COMPLSB_RESETVAL (0x00000000u)

#define CSL_RTC_COMPLSB_RESETVAL (0x00000000u)

/* COMPMSB */


#define CSL_RTC_COMPMSB_COMPMSB_MASK (0x000000FFu)
#define CSL_RTC_COMPMSB_COMPMSB_SHIFT (0x00000000u)
#define CSL_RTC_COMPMSB_COMPMSB_RESETVAL (0x00000000u)

#define CSL_RTC_COMPMSB_RESETVAL (0x00000000u)

/* OSC */


#define CSL_RTC_OSC_SWRESET_MASK (0x00000020u)
#define CSL_RTC_OSC_SWRESET_SHIFT (0x00000005u)
#define CSL_RTC_OSC_SWRESET_RESETVAL (0x00000000u)

#define CSL_RTC_OSC_OSC32KPWRDN_MASK (0x00000010u)
#define CSL_RTC_OSC_OSC32KPWRDN_SHIFT (0x00000004u)
#define CSL_RTC_OSC_OSC32KPWRDN_RESETVAL (0x00000000u)

#define CSL_RTC_OSC_SWRESPROG_MASK (0x0000000Fu)
#define CSL_RTC_OSC_SWRESPROG_SHIFT (0x00000000u)
#define CSL_RTC_OSC_SWRESPROG_RESETVAL (0x00000007u)

#define CSL_RTC_OSC_RESETVAL (0x00000007u)

/* SCRATCH0 */

#define CSL_RTC_SCRATCH0_MASK (0xFFFFFFFFu)
#define CSL_RTC_SCRATCH0_SHIFT (0x00000000u)
#define CSL_RTC_SCRATCH0_RESETVAL (0x00000000u)

/* SCRATCH1 */

#define CSL_RTC_SCRATCH1_MASK (0xFFFFFFFFu)
#define CSL_RTC_SCRATCH1_SHIFT (0x00000000u)
#define CSL_RTC_SCRATCH1_RESETVAL (0x00000000u)

/* SCRATCH2 */

#define CSL_RTC_SCRATCH2_MASK (0xFFFFFFFFu)
#define CSL_RTC_SCRATCH2_SHIFT (0x00000000u)
#define CSL_RTC_SCRATCH2_RESETVAL (0x00000000u)

/* KICK0 */

#define CSL_RTC_KICK0_MASK (0xFFFFFFFFu)
#define CSL_RTC_KICK0_SHIFT (0x00000000u)
#define CSL_RTC_KICK0_RESETVAL (0x00000000u)
/*----VAL Tokens----*/
#define CSL_RTC_KICK0_KEY (0x83E70B13u)

/* KICK1 */

#define CSL_RTC_KICK1_MASK (0xFFFFFFFFu)
#define CSL_RTC_KICK1_SHIFT (0x00000000u)
#define CSL_RTC_KICK1_RESETVAL (0x00000000u)
/*----VAL Tokens----*/
#define CSL_RTC_KICK1_KEY (0x95A4F1E0u)

#endif
